/*********************************************************************
 *
 *  $Id: svn_id $
 *
 *  Implements YOrientationProxy, the Proxy API for Orientation
 *
 *  - - - - - - - - - License information: - - - - - - - - -
 *
 *  Copyright (C) 2011 and beyond by Yoctopuce Sarl, Switzerland.
 *
 *  Yoctopuce Sarl (hereafter Licensor) grants to you a perpetual
 *  non-exclusive license to use, modify, copy and integrate this
 *  file into your software for the sole purpose of interfacing
 *  with Yoctopuce products.
 *
 *  You may reproduce and distribute copies of this file in
 *  source or object form, as long as the sole purpose of this
 *  code is to interface with Yoctopuce products. You must retain
 *  this notice in the distributed source file.
 *
 *  You should refer to Yoctopuce General Terms and Conditions
 *  for additional information regarding your rights and
 *  obligations.
 *
 *  THE SOFTWARE AND DOCUMENTATION ARE PROVIDED 'AS IS' WITHOUT
 *  WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING
 *  WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY, FITNESS
 *  FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO
 *  EVENT SHALL LICENSOR BE LIABLE FOR ANY INCIDENTAL, SPECIAL,
 *  INDIRECT OR CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA,
 *  COST OF PROCUREMENT OF SUBSTITUTE GOODS, TECHNOLOGY OR
 *  SERVICES, ANY CLAIMS BY THIRD PARTIES (INCLUDING BUT NOT
 *  LIMITED TO ANY DEFENSE THEREOF), ANY CLAIMS FOR INDEMNITY OR
 *  CONTRIBUTION, OR OTHER SIMILAR COSTS, WHETHER ASSERTED ON THE
 *  BASIS OF CONTRACT, TORT (INCLUDING NEGLIGENCE), BREACH OF
 *  WARRANTY, OR OTHERWISE.
 *
 *********************************************************************/


using System;
using System.Collections.Generic;
using System.IO;
using System.Threading;
using System.Timers;
using System.Globalization;
using System.Text.RegularExpressions;
using YoctoLib;

namespace YoctoProxyAPI
{
    //--- (YOrientation class start)
    static public partial class YoctoProxyManager
    {
        public static YOrientationProxy FindOrientation(string name)
        {
            // cases to handle:
            // name =""  no matching unknwn
            // name =""  unknown exists
            // name != "" no  matching unknown
            // name !="" unknown exists
            YOrientation func = null;
            YOrientationProxy res = (YOrientationProxy)YFunctionProxy.FindSimilarUnknownFunction("YOrientationProxy");

            if (name == "") {
                if (res != null) return res;
                res = (YOrientationProxy)YFunctionProxy.FindSimilarKnownFunction("YOrientationProxy");
                if (res != null) return res;
                func = YOrientation.FirstOrientation();
                if (func != null) {
                    name = func.get_hardwareId();
                    if (func.get_userData() != null) {
                        return (YOrientationProxy)func.get_userData();
                    }
                }
            } else {
                func = YOrientation.FindOrientation(name);
                if (func.get_userData() != null) {
                    return (YOrientationProxy)func.get_userData();
                }
            }
            if (res == null) {
                res = new YOrientationProxy(func, name);
            }
            if (func != null) {
                res.linkToHardware(name);
                if(func.isOnline()) res.arrival();
            }
            return res;
        }
    }

/**
 * <summary>
 *   The <c>YOrientation</c> class allows you to read and configure Yoctopuce orientation sensors.
 * <para>
 *   It inherits from <c>YSensor</c> class the core functions to read measurements,
 *   to register callback functions, and to access the autonomous datalogger.
 * </para>
 * <para>
 * </para>
 * </summary>
 */
    public class YOrientationProxy : YSensorProxy
    {
        /**
         * <summary>
         *   Retrieves an orientation sensor for a given identifier.
         * <para>
         *   The identifier can be specified using several formats:
         * </para>
         * <para>
         * </para>
         * <para>
         *   - FunctionLogicalName
         * </para>
         * <para>
         *   - ModuleSerialNumber.FunctionIdentifier
         * </para>
         * <para>
         *   - ModuleSerialNumber.FunctionLogicalName
         * </para>
         * <para>
         *   - ModuleLogicalName.FunctionIdentifier
         * </para>
         * <para>
         *   - ModuleLogicalName.FunctionLogicalName
         * </para>
         * <para>
         * </para>
         * <para>
         *   This function does not require that the orientation sensor is online at the time
         *   it is invoked. The returned object is nevertheless valid.
         *   Use the method <c>YOrientation.isOnline()</c> to test if the orientation sensor is
         *   indeed online at a given time. In case of ambiguity when looking for
         *   an orientation sensor by logical name, no error is notified: the first instance
         *   found is returned. The search is performed first by hardware name,
         *   then by logical name.
         * </para>
         * <para>
         *   If a call to this object's is_online() method returns FALSE although
         *   you are certain that the matching device is plugged, make sure that you did
         *   call registerHub() at application initialization time.
         * </para>
         * <para>
         * </para>
         * </summary>
         * <param name="func">
         *   a string that uniquely characterizes the orientation sensor, for instance
         *   <c>MyDevice.orientation</c>.
         * </param>
         * <returns>
         *   a <c>YOrientation</c> object allowing you to drive the orientation sensor.
         * </returns>
         */
        public static YOrientationProxy FindOrientation(string func)
        {
            return YoctoProxyManager.FindOrientation(func);
        }
        //--- (end of YOrientation class start)
        //--- (YOrientation definitions)
        public const int _CounterClockwise_INVALID = 0;
        public const int _CounterClockwise_FALSE = 1;
        public const int _CounterClockwise_TRUE = 2;
        public const string _Command_INVALID = YAPI.INVALID_STRING;
        public const double _ZeroOffset_INVALID = Double.NaN;

        // reference to real YoctoAPI object
        protected new YOrientation _func;
        // property cache
        protected int _counterClockwise = _CounterClockwise_INVALID;
        protected double _zeroOffset = _ZeroOffset_INVALID;
        //--- (end of YOrientation definitions)

        //--- (YOrientation implementation)
        internal YOrientationProxy(YOrientation hwd, string instantiationName) : base(hwd, instantiationName)
        {
            InternalStuff.log("Orientation " + instantiationName + " instantiation");
            base_init(hwd, instantiationName);
        }

        // perform the initial setup that may be done without a YoctoAPI object (hwd can be null)
        internal override void base_init(YFunction hwd, string instantiationName)
        {
            _func = (YOrientation) hwd;
           	base.base_init(hwd, instantiationName);
        }

        // link the instance to a real YoctoAPI object
        internal override void linkToHardware(string hwdName)
        {
            YOrientation hwd = YOrientation.FindOrientation(hwdName);
            // first redo base_init to update all _func pointers
            base_init(hwd, hwdName);
            // then setup Yocto-API pointers and callbacks
            init(hwd);
        }

        // perform the 2nd stage setup that requires YoctoAPI object
        protected void init(YOrientation hwd)
        {
            if (hwd == null) return;
            base.init(hwd);
            InternalStuff.log("registering Orientation callback");
            _func.registerValueCallback(valueChangeCallback);
        }

        /**
         * <summary>
         *   Enumerates all functions of type Orientation available on the devices
         *   currently reachable by the library, and returns their unique hardware ID.
         * <para>
         *   Each of these IDs can be provided as argument to the method
         *   <c>YOrientation.FindOrientation</c> to obtain an object that can control the
         *   corresponding device.
         * </para>
         * </summary>
         * <returns>
         *   an array of strings, each string containing the unique hardwareId
         *   of a device function currently connected.
         * </returns>
         */
        public static new string[] GetSimilarFunctions()
        {
            List<string> res = new List<string>();
            YOrientation it = YOrientation.FirstOrientation();
            while (it != null)
            {
                res.Add(it.get_hardwareId());
                it = it.nextOrientation();
            }
            return res.ToArray();
        }

        protected override void functionArrival()
        {
            base.functionArrival();
        }

        protected override void moduleConfigHasChanged()
       	{
            base.moduleConfigHasChanged();
            _counterClockwise = _func.get_counterClockwise()+1;
            _zeroOffset = _func.get_zeroOffset();
        }

        /**
         * <summary>
         *   Returns a value indicating whether the sensor is operating in a counterclockwise direction.
         * <para>
         * </para>
         * <para>
         * </para>
         * </summary>
         * <returns>
         *   either <c>YOrientation.COUNTERCLOCKWISE_FALSE</c> or <c>YOrientation.COUNTERCLOCKWISE_TRUE</c>,
         *   according to a value indicating whether the sensor is operating in a counterclockwise direction
         * </returns>
         * <para>
         *   On failure, throws an exception or returns <c>YOrientation.COUNTERCLOCKWISE_INVALID</c>.
         * </para>
         */
        public int get_counterClockwise()
        {
            if (_func == null) {
                throw new YoctoApiProxyException("No Orientation connected");
            }
            // our enums start at 0 instead of the 'usual' -1 for invalid
            return _func.get_counterClockwise()+1;
        }

        /**
         * <summary>
         *   Defines the operating direction of the sensor.
         * <para>
         *   Remember to call the <c>saveToFlash()</c> method of the module if the
         *   modification must be kept.
         * </para>
         * <para>
         * </para>
         * </summary>
         * <param name="newval">
         *   either <c>YOrientation.COUNTERCLOCKWISE_FALSE</c> or <c>YOrientation.COUNTERCLOCKWISE_TRUE</c>
         * </param>
         * <para>
         * </para>
         * <returns>
         *   <c>0</c> if the call succeeds.
         * </returns>
         * <para>
         *   On failure, throws an exception or returns a negative error code.
         * </para>
         */
        public int set_counterClockwise(int newval)
        {
            if (_func == null) {
                throw new YoctoApiProxyException("No Orientation connected");
            }
            if (newval == _CounterClockwise_INVALID) {
                return YAPI.SUCCESS;
            }
            // our enums start at 0 instead of the 'usual' -1 for invalid
            return _func.set_counterClockwise(newval-1);
        }

        // property with cached value for instant access (configuration)
        /// <value>Value indicating whether the sensor is operating in a counterclockwise direction.</value>
        public int CounterClockwise
        {
            get
            {
                if (_func == null) {
                    return _CounterClockwise_INVALID;
                }
                if (_online) {
                    return _counterClockwise;
                }
                return _CounterClockwise_INVALID;
            }
            set
            {
                setprop_counterClockwise(value);
            }
        }

        // private helper for magic property
        private void setprop_counterClockwise(int newval)
        {
            if (_func == null) {
                return;
            }
            if (!(_online)) {
                return;
            }
            if (newval == _CounterClockwise_INVALID) {
                return;
            }
            if (newval == _counterClockwise) {
                return;
            }
            // our enums start at 0 instead of the 'usual' -1 for invalid
            _func.set_counterClockwise(newval-1);
            _counterClockwise = newval;
        }

        /**
         * <summary>
         *   Sets an offset between the orientation reported by the sensor and the actual orientation.
         * <para>
         *   This
         *   can typically be used  to compensate for mechanical offset. This offset can also be set
         *   automatically using the zero() method.
         *   Remember to call the <c>saveToFlash()</c> method of the module if the modification must be kept.
         * </para>
         * <para>
         * </para>
         * </summary>
         * <param name="newval">
         *   a floating point number
         * </param>
         * <para>
         * </para>
         * <returns>
         *   <c>0</c> if the call succeeds.
         * </returns>
         * <para>
         *   On failure, throws an exception or returns a negative error code.
         * </para>
         */
        public int set_zeroOffset(double newval)
        {
            if (_func == null) {
                throw new YoctoApiProxyException("No Orientation connected");
            }
            if (newval == _ZeroOffset_INVALID) {
                return YAPI.SUCCESS;
            }
            return _func.set_zeroOffset(newval);
        }

        /**
         * <summary>
         *   Returns the Offset between the orientation reported by the sensor and the actual orientation.
         * <para>
         * </para>
         * <para>
         * </para>
         * </summary>
         * <returns>
         *   a floating point number corresponding to the Offset between the orientation reported by the sensor
         *   and the actual orientation
         * </returns>
         * <para>
         *   On failure, throws an exception or returns <c>YOrientation.ZEROOFFSET_INVALID</c>.
         * </para>
         */
        public double get_zeroOffset()
        {
            double res;
            if (_func == null) {
                throw new YoctoApiProxyException("No Orientation connected");
            }
            res = _func.get_zeroOffset();
            if (res == YAPI.INVALID_DOUBLE) {
                res = Double.NaN;
            }
            return res;
        }

        // property with cached value for instant access (configuration)
        /// <value>Offset between the orientation reported by the sensor and the actual orientation.</value>
        public double ZeroOffset
        {
            get
            {
                if (_func == null) {
                    return _ZeroOffset_INVALID;
                }
                if (_online) {
                    return _zeroOffset;
                }
                return _ZeroOffset_INVALID;
            }
            set
            {
                setprop_zeroOffset(value);
            }
        }

        // private helper for magic property
        private void setprop_zeroOffset(double newval)
        {
            if (_func == null) {
                return;
            }
            if (!(_online)) {
                return;
            }
            if (newval == _ZeroOffset_INVALID) {
                return;
            }
            if (newval == _zeroOffset) {
                return;
            }
            _func.set_zeroOffset(newval);
            _zeroOffset = newval;
        }

        /**
         * <summary>
         *   Reset the sensor's zero to current position by automatically setting a new offset.
         * <para>
         *   Remember to call the <c>saveToFlash()</c> method of the module if the modification must be kept.
         * </para>
         * </summary>
         * <returns>
         *   <c>0</c> if the call succeeds.
         *   On failure, throws an exception or returns a negative error code.
         * </returns>
         */
        public virtual int zero()
        {
            if (_func == null) {
                throw new YoctoApiProxyException("No Orientation connected");
            }
            return _func.zero();
        }

        /**
         * <summary>
         *   Cancels any calibration set with <c>set_calibration</c>.
         * <para>
         *   This function
         *   is equivalent to calling <c>set_calibration</c> with only zeros.
         * </para>
         * </summary>
         * <returns>
         *   <c>0</c> if the call succeeds.
         * </returns>
         * <para>
         *   On failure, throws an exception or returns a negative error code.
         * </para>
         */
        public virtual int clearCalibration()
        {
            if (_func == null) {
                throw new YoctoApiProxyException("No Orientation connected");
            }
            return _func.clearCalibration();
        }
    }
    //--- (end of YOrientation implementation)
}

